Wikipedia / Subset sum problem
Wikipedia / Subset sum problem
The subset sum problem (SSP) is a decision problem in computer science. In its most general formulation, there is a multiset. The problem is known to be NP-complete. Moreover, some restricted variants of it are NP-complete too, for example:
The variant in which all inputs are positive.
, the answer is yes sums to zero.
. This special case of SSP is known as the partition problem.
SSP can also be regarded as an optimization problem: find a subset whose sum is at most T, and subject to that, as close as possible to T. It is NP-hard, but there are several algorithms that can solve it reasonably quickly in practice.
SSP is a special case of the knapsack problem and of the multiple subset sum problem.
Computational hardness
The time complexity of SSP depends on two parameters:
- the number of input integers. If n is a small fixed number, then an exhaustive search for the solution is practical.
- the precision of the problem, stated as the number of binary place values that it takes to state the problem. If L is a small fixed number, then there are dynamic programming algorithms that can solve it exactly.
As both n and L grow large, SSP is NP-hard. The complexity of the best known algorithms is exponential in the smaller of the two parameters n and L. The problem is NP-hard even when all input integers are positive (and the target-sum T is a part of the input). This can be proved by a direct reduction from 3SAT. It can also be proved by reduction from 3-dimensional matching (3DM):
We are given an instance of 3DM, where the vertex sets are W, X, Y. Each set has n vertices. There are m edges, where each edge contains exactly one vertex from each of W, X, Y. Denote L := ceiling(log2(m+1)), so that L is larger than the number of bits required to represent the number of edges.
We construct an instance of SSP with m positive integers. The integers are described by their binary representation. Each input integer can be represented by 3nL bits, divided into 3n zones of L bits. Each zone corresponds to a vertex.
For each edge (w,x,y) in the 3DM instance, there is an integer in the SSP instance, in which exactly three bits are "1": the least-significant bits in the zones of the vertices w, x, and y. For example, if n=10 and L=3, and W=(0,...,9), X=(10,...,19), Y=(20,...,29), then the edge (0, 10, 20) is represented by the number (20+230+260).
The target sum T in the SSP instance is set to an integer with "1" in the least-significant bit of every zone, that is, (20+21+...+23n-1).
If the 3DM instance has a perfect matching, then summing the corresponding integers in the SSP instance yields exactly T.
Conversely, if the SSP instance has a subset with sum exactly T, then, since the zones are sufficiently large so that there are no "carries" from one zone to the next, the sum must correspond to a perfect matching in the 3DM instance.
The following variants are also known to be NP-hard:
The input integers can be both positive and negative, and the target-sum T = 0. This can be proved by reduction from the variant with positive integers. Denote that variant by SubsetSumPositive and the current variant by SubsetSumZero. Given an instance (S, T) of SubsetSumPositive, construct an instance of SubsetSumZero by adding a single element with value T. Given a solution to the SubsetSumPositive instance, adding the T yields a solution to the SubsetSumZero instance. Conversely, given a solution to the SubsetSumZero instance, it must contain the T (since all integers in S are positive), so to get a sum of zero, it must also contain a subset of S with a sum of +T, which is a solution of the SubsetSumPositive instance.
The input integers are positive, and T = sum(S)/2. This can also be proved by reduction from the general variant; see partition problem.
The analogous counting problem #SSP, which asks to enumerate the number of subsets summing to the target, is #P-complete.
Exponential time algorithms
There are several ways to solve SSP in time exponential in n.
Inclusion–exclusion
The most naïve algorithm would be to cycle through all subsets of n subsets and, to check each subset, we need to sum at most n elements.
The algorithm can be implemented by depth-first search of a binary tree. The run-time can be improved by several heuristics:
Process the input numbers in descending order.
If the integers included in a given node exceed the sum of the best subset found so far, the node is pruned.
If the integers included in a given node, plus all remaining integers, are less than the sum of the best subset found so far, the node is pruned.
Horowitz and Sahni
In 1974, Horowitz and Sahni. The algorithm splits arbitrarily the n possible subsets of its elements. Each of these two lists is then sorted. Using even the fastest comparison sorting algorithm. Given the two sorted lists, the algorithm can check if an element of the first array and an element of the second array sum up to T. To do that, the algorithm passes through the first array in decreasing order (starting at the largest element) and the second array in increasing order (starting at the smallest element). Whenever the sum of the current element in the first array and the current element in the second array is more than T, the algorithm moves to the next element in the first array. If it is less than T, the algorithm moves to the next element in the second array. If two elements that sum to T are found, it stops. (The sub-problem for two elements sum is known as two-sum.)
Schroeppel and Shamir
In 1981, Schroeppel and Shamir presented an algorithm. Rather than generating and storing all subsets of n/2 elements in advance, they partition the elements into 4 sets of n/4 elements each, and generate subsets of n/2 element pairs dynamically using a min heap given 4 lists of length k.
Due to space requirements, the HS algorithm is practical for up to about 50 integers, and the SS algorithm is practical for up to 100 integers.
Howgrave-Graham and Joux
In 2010, Howgrave-Graham and Joux presented a probabilistic algorithm. It solves only the decision problem, cannot prove there is no solution for a given sum, and does not return the subset sum closest to T.
The techniques of Howgrave-Graham and Joux were subsequently extended. A more recent generalization.
Pseudo-polynomial time dynamic programming solutions
SSP can be solved in pseudo-polynomial time using dynamic programming. Suppose we have the following sequence of elements in an instance:
We define a state as a pair (i, s) of integers. This state represents the fact that
which sums to ."
Each state (i, s) has two next states:
(i+1, s is not included in the subset;
(i+1, s is included in the subset.
Starting from the initial state (0, 0), it is possible to use any graph search algorithm (e.g. BFS) to search the state (N, T). If the state is found, then by backtracking we can find a subset with a sum of exactly T.
The run-time of this algorithm is at most linear in the number of states. The number of states is at most N times the number of different possible sums. Let be the sum of the negative values and the sum of the positive values; the number of different possible sums is at most B-A. For example, if all input values are positive and bounded by some constant C, then B is at most N C.
is not polynomial in the size of the problem, which is the number of bits used to represent it. This algorithm is polynomial in the values of and , which are exponential in their numbers of bits. However, Subset Sum encoded in unary is in P, since then the size of the encoding is linear in B-A. Hence, Subset Sum is only weakly NP-Complete.
is positive and bounded by a fixed constant (note that this is for the version of the problem where the target sum is not necessarily zero, as otherwise the problem would be trivial). algorithm for the subset sum problem where is the sum we need to find. time algorithm.
In 2014, Curtis and Sanches found a simple recursion highly scalable in SIMD space, where is the lowest integer. This is the best theoretical parallel complexity known so far.
A comparison of practical results and the solution of hard instances of the SSP is discussed by Curtis and Sanches.
Polynomial time approximation algorithms
Suppose all inputs are positive. An approximation algorithm to SSP aims to find a subset of S with a sum of at most T and at least r times the optimal sum, where r is a number in (0,1) called the approximation ratio.
Simple 1/2-approximation
The following very simple algorithm has an approximation ratio of 1/2:
Order the inputs by descending value;
Put the next-largest input into the subset, as long as it fits there.
When this algorithm terminates, either all inputs are in the subset (which is obviously optimal), or there is an input that does not fit. The first such input is smaller than all previous inputs that are in the subset and the sum of inputs in the subset is more than T/2 otherwise the input also is less than T/2 and it would fit in the set. Such a sum greater than T/2 is obviously more than OPT/2.
Fully-polynomial time approximation schemeFPTAS
. Its run time is polynomial in . Recall that n is the number of inputs and T is the upper bound to the subset sum.
initialize a list L to contain one element 0.
for each i from 1 to n do
let Ui be a list containing all elements y in L, and all sums xi + y for all y in L.
sort Ui in ascending order
make L empty
let y be the smallest element of Ui
add y to L
for each element z of Ui in increasing order do
// Trim the list by eliminating numbers close to one another
// and throw out elements greater than the target sum T.
if y + ε T/n < z ≤ T then
y = z
add z to L
return the largest element in L.Note that without the trimming step (the inner "for each" loop), the list L subsets of inputs. The trimming step does two things:
It ensures that all sums remaining in L are below T, so they are feasible solutions to the subset-sum problem.
.
These properties together guarantee that the list .
When the algorithm ends, if the optimal sum is in , so .
The above algorithm provides an exact solution to SSP in the case that the input numbers are small (and non-negative). If any sum of the numbers can be specified with at most is equivalent to solving it exactly. Then, the polynomial time algorithm for approximate subset sum becomes an exact algorithm with running time polynomial in (i.e., exponential in ).
Kellerer, Mansini, Pferschy and Speranza and Kellerer, Pferschy and Pisinger present other FPTASes for subset sum.
See also
- a generalization of SSP in which each input item has both a value and a weight. The goal is to maximize the value subject to a bound on the total weight.
- a generalization of SSP in which one should choose several subsets.
References
Further reading
A3.2: SP13, pg.223.